import { BookOfMagicInk } from "./module/book.js";
import { HtmlUtil } from "./module/htmlUtil.js";



Hooks.once('ready', async function() {
    HtmlUtil.book = await new BookOfMagicInk();
});

Hooks.once('init', () => {
    game.settings.register("arcane-ink", "hotkey", {
        name: game.i18n.localize("MI.settings.hotkey"),
        hint: game.i18n.localize("MI.settings.hotkeyHint"),
        scope: "world",
        config: true,
        type: String,
        default: "j",
    });
    game.settings.register("arcane-ink", "hotkeyRus", {
        name: game.i18n.localize("MI.settings.hotkeyRus"),
        hint: game.i18n.localize("MI.settings.hotkeyRusHint"),
        scope: "world",
        config: true,
        type: String,
        default: "о",
    });
    
});

Hooks.on('renderJournalTextPageSheet', (app, html, data) => {
    let title = game.i18n.localize("MI.name");
    HtmlUtil.appendHeaderButton(html, title, ev => {
        if (game.user.isGM){
            HtmlUtil.book.render(true);
        }
    });
});

window.addEventListener('keydown', (event) => {
    const hotkey = game.settings.get("arcane-ink", "hotkey");
    const hotkeyRus = game.settings.get("arcane-ink", "hotkeyRus");
    // Проверка нажатия нужной клавиши && event.ctrlKey && event.shiftKey
    if (event.key === hotkey && event.ctrlKey || event.key === hotkeyRus && event.ctrlKey) {
        // Вызов действия
        if (game.user.isGM){
            HtmlUtil.book.render(true);
        }
        // Добавьте здесь ваше действие
        event.preventDefault(); // Отменить стандартное действие
    }
});