export class HtmlUtil {
    static book;
    static appendHeaderButton(html, title, fn) {
        let openBtn = $(`<a class="potion" title="${title}"><i class="fas fa-flask-round-potion"></i>${title}</a>`);
        openBtn.click(fn);
        html.closest('.app').find('.potion').remove();
        let titleElement = html.closest('.app').find('.window-title');
        openBtn.insertAfter(titleElement);
    }

    static toDivPack(listElements){
        let result = [];
        for (const _element of listElements){
            let div = document.createElement('div');
            div.appendChild(_element);
            result.push(div);
        }
        return result;
    }

    static createElement(element, args) {
        //args = {elementClass = [], id, name, for, data, data_tab, data-group, type, value, src, text}
        const _element = document.createElement(element);
        if (args?.elementClass){
            for (let _class = 0; _class < args.elementClass.length; _class ++){
                _element.classList.add(args.elementClass[_class]);
            }
        }
        if (args?.id){
            _element.setAttribute("id", args.id);
        }
        if (args?.name){
            _element.setAttribute("name", args.name);
        }
        if (args?.for){
            _element.setAttribute("for", args.for);
        }
        if (args?.data){
            _element.setAttribute("data", args.data);
        }
        if (args?.size){
            _element.setAttribute("size", args.size);
        }
        if (args?.multiple){
            _element.setAttribute("multiple", args.multiple);
        }
        if (args?.data_tab){
            _element.setAttribute("data-tab", args.data_tab);
        }
        if (args?.data_group){
            _element.setAttribute("data-group", args.data_group);
        }
        if (args?.data_tooltip){
            _element.setAttribute("data-tooltip", args.data_tooltip);
        }
        if (args?.data_tooltip_direction){
            _element.setAttribute("data-tooltip-direction", args.data_tooltip_direction);
        }
        if (args?.type){
            _element.setAttribute("type", args.type);
        }
        if (args?.value){
            _element.setAttribute("value", args.value);
        }
        if (args?.src){
            _element.setAttribute("src", args.src);
        }
        if (args?.min){
            _element.setAttribute("min", args.min);
        }
        if (args?.max){
            _element.setAttribute("max", args.max);
        }
        if (args?.step){
            _element.setAttribute("step", args.step);
        }
        if (args?.placeholder){
            _element.setAttribute("placeholder", args.placeholder);
        }
        if (args?.text){
            _element.innerHTML = args.text;
        }
        
        return _element;
    }
    static appendElements(_element, _elements){
        // element, elements = []
        for (const _elementIn of _elements){
            _element.appendChild(_elementIn);
        }
    }
    static sortDict(_dict){
        return Object.fromEntries(
            Object.entries(_dict).sort(([, a], [, b]) => a.localeCompare(b))
          );
    }
}