import { HtmlUtil } from "../htmlUtil.js";

export function createAwardsTab(){
    let awardsContainer = HtmlUtil.createElement("div", {elementClass: ["awardsContainer"]});
    let awardsList = [
        [
            {"label": {for: "pp", text: game.i18n.localize("MI.awordsContent.pp")}},
            {"input": {type: "number", id: "pp", name: "pp", value: ""}},
            {"img": {src: "systems/dnd5e/icons/currency/platinum.webp", name: "ppImg"}},
        ],
        [
            {"label": {for: "gp", text: game.i18n.localize("MI.awordsContent.gp")}},
            {"input": {type: "number", id: "gp", name: "gp", value: ""}},
            {"img": {src: "systems/dnd5e/icons/currency/gold.webp", name: "gpImg"}},
        ],
        [
            {"label": {for: "ep", text: game.i18n.localize("MI.awordsContent.ep")}},
            {"input": {type: "number", id: "ep", name: "ep", value: ""}},
            {"img": {src: "systems/dnd5e/icons/currency/electrum.webp", name: "epImg"}},
        ],
        [
            {"label": {for: "sp", text: game.i18n.localize("MI.awordsContent.sp")}},
            {"input": {type: "number", id: "sp", name: "sp", value: ""}},
            {"img": {src: "systems/dnd5e/icons/currency/silver.webp", name: "spImg"}},
        ],
        [
            {"label": {for: "cp", text: game.i18n.localize("MI.awordsContent.cp")}},
            {"input": {type: "number", id: "cp", name: "cp", value: ""}},
            {"img": {src: "systems/dnd5e/icons/currency/copper.webp", name: "cpImg"}},
        ],
        [
            {"label": {for: "xp", text: game.i18n.localize("MI.awordsContent.xp")}},
            {"input": {type: "number", id: "xp", name: "xp", value: ""}},
            {"img": {src: "systems/dnd5e/ui/inspiration.webp", name: "xpImg"}},
        ],
        [
            {"label": {for: "party", text: game.i18n.localize("MI.awordsContent.party")}},
            {"input": {type: "checkbox", id: "party", name: "party", value: ""}},
            {"i": {elementClass: ["fa-solid", "fa-people-group"], name: "partyImg"}},
        ],
        [
            {"label": {for: "each", text: game.i18n.localize("MI.awordsContent.each")}},
            {"input": {type: "checkbox", id: "each", name: "each", value: ""}},
            {"i": {elementClass: ["fa-solid", "fa-fw", "fa-user"], name: "eachImg"}},
        ]
    ];
    for (let divs of awardsList){
        let divGroup = HtmlUtil.createElement("div", {elementClass: ["form-group"]});
        for (let div of divs){
            let elements = [];
            for (let [key, value] of Object.entries(div)){
                let element = HtmlUtil.createElement(key, value);
                elements.push(element);
            }
            HtmlUtil.appendElements(divGroup, HtmlUtil.toDivPack(elements));
        }
        awardsContainer.appendChild(divGroup);
    }
    // <div class="buttonClearContainer"><button id="buttonClear" class="buttonClear button">${game.i18n.localize("MI.awordsContent.clear")}</button></div>
    // <div class="buttonAwordsContainer"><button id="buttonAwords" class="buttonAwords button">${game.i18n.localize("MI.awordsContent.setAward")}</button></div>
    let buttonClearContainer = HtmlUtil.createElement("div", {elementClass: ["buttonClearContainer"]});
    let buttonClear = HtmlUtil.createElement("button", {elementClass: ["buttonClear", "button"], id:"buttonClear", text: game.i18n.localize("MI.awordsContent.clear")});
    let buttonAwordsContainer = HtmlUtil.createElement("div", {elementClass: ["buttonAwordsContainer"]});
    let buttonAwords = HtmlUtil.createElement("button", {elementClass: ["buttonAwords", "button"], id:"buttonAwords", text: game.i18n.localize("MI.awordsContent.setAward")});
    buttonClearContainer.appendChild(buttonClear);
    buttonAwordsContainer.appendChild(buttonAwords);
    HtmlUtil.appendElements(awardsContainer, [buttonClearContainer, buttonAwordsContainer]);

    return awardsContainer.outerHTML;
}