import { HtmlUtil } from "../htmlUtil.js";

export function createColorContentTab(){
    let colorContent = HtmlUtil.createElement("div", {elementClass: ["ColorContent"]});
    let row = HtmlUtil.createElement("div", {elementClass: ["ColorContentRow"]});
    let labelColor = HtmlUtil.createElement("label", {for: "colour", text: game.i18n.localize("MI.colorContent.color")});
    let color = HtmlUtil.createElement("input", {type: "color", id: "colour", name: "color", value: "#ffffff"});
    let labelTransparent = HtmlUtil.createElement("label", {for: "transparent", text: game.i18n.localize("MI.colorContent.transparent")});
    let transparent = HtmlUtil.createElement("input", {type: "range", id: "transparent", name: "transparent", value: "1", min: "0", max: "1", step: "0.01"});
    let divPackedColor = HtmlUtil.toDivPack([
        labelColor, 
        color,
        labelTransparent,
        transparent
    ]);
    HtmlUtil.appendElements(row, divPackedColor);
    let divColorHex = document.createElement("div");
    let colorHex = HtmlUtil.createElement("input", {type: "text", id: "colorHex", name: "colorHex", value: "#ffffff"});
    divColorHex.appendChild(colorHex);
    let rowNameColor = HtmlUtil.createElement("div", {elementClass: ["ColorContent"]});
    let nameColor = HtmlUtil.createElement("input", {type: "text", id: "nameColor"});
    let buttonColorAdd = HtmlUtil.createElement("button", {elementClass: ["buttonColorAdd", "button"], id: "buttonColorAdd", text: game.i18n.localize("MI.colorContent.save")});
    let divPackedColorAdd = HtmlUtil.toDivPack([nameColor, buttonColorAdd]);
    HtmlUtil.appendElements(rowNameColor, divPackedColorAdd);
    let rowButtonColor = HtmlUtil.createElement("div", {elementClass: ["ColorContent"]});

    

    let buttonColor = HtmlUtil.createElement("button", {elementClass: ["buttonColor", "button"], id: "buttonColor", text: game.i18n.localize("MI.colorContent.setColourText")});
    let buttonColorBackground = HtmlUtil.createElement("button", {elementClass: ["buttonColorBackground", "button"], id: "buttonColorBackground", text: game.i18n.localize("MI.colorContent.setColourBorder")});
    let divPackedbuttonColor = HtmlUtil.toDivPack([buttonColor, buttonColorBackground]);
    HtmlUtil.appendElements(rowButtonColor, divPackedbuttonColor);

    let rowBorderStyle = HtmlUtil.createElement("div", {elementClass: ["ColorContent"]});
    let boerderSelect = HtmlUtil.createElement("select", {elementClass: ["boerderSelect"], name: "boerderSelect"});
    let borderStyle = {
        "none": game.i18n.localize("MI.colorContent.borderStyle.none"),
        "dotted": game.i18n.localize("MI.colorContent.borderStyle.dotted"),
        "dashed": game.i18n.localize("MI.colorContent.borderStyle.dashed"),
        "solid": game.i18n.localize("MI.colorContent.borderStyle.solid"),
        "double": game.i18n.localize("MI.colorContent.borderStyle.double"),
        "groove": game.i18n.localize("MI.colorContent.borderStyle.groove"),
        "ridge": game.i18n.localize("MI.colorContent.borderStyle.ridge"),
        "inset": game.i18n.localize("MI.colorContent.borderStyle.inset"),
        "outset": game.i18n.localize("MI.colorContent.borderStyle.outset"),
        "pictures": game.i18n.localize("MI.colorContent.borderStyle.pictures")
    }
    for (let border in borderStyle){
        let option = HtmlUtil.createElement("option", {value: border, text: borderStyle[border]});
        boerderSelect.appendChild(option);
    }
    let borderSize = HtmlUtil.createElement("input", {elementClass: ["borderSize"], id: "borderSize", value: 1, type:"number", step:"0.01"});
    let boerderUnitSelect = HtmlUtil.createElement("select", {elementClass: ["boerderUnitSelect"], id: "boerderUnitSelect"});
    let borderUnits = {
        "rem": "rem",
        "px": "px",
        "em": "em",
        "%": "%",
        "vw": "vw",
        "vh": "vh",
        "vmin": "vmin",
        "vmax": "vmax"
    }
    for (let unit in borderUnits){
        let option = HtmlUtil.createElement("option", {value: unit, text: borderUnits[unit]});
        boerderUnitSelect.appendChild(option);
    }
    let buttonBackgroundColorBorder = HtmlUtil.createElement("button", {elementClass: ["buttonBackgroundColorBorder", "button"], id: "buttonBackgroundColorBorder", text: `${game.i18n.localize("MI.colorContent.buttonBackgroundColorBorder")}`});
    let buttonColorBorder = HtmlUtil.createElement("button", {elementClass: ["buttonColorBorder", "button"], id: "buttonColorBorder", text: `<div class="borderTemplate" name="borderTemplate">${game.i18n.localize("MI.colorContent.buttonColorBorder")}</div>`});
    let angle = HtmlUtil.createElement("input", {type: "range", id: "angle", name: "angle", value: "0", min: "0", max: "50", step: "0.1"});
    let divPackedBorderStyle = HtmlUtil.toDivPack([boerderSelect, borderSize, boerderUnitSelect, angle, buttonBackgroundColorBorder, buttonColorBorder]);
    HtmlUtil.appendElements(rowBorderStyle, divPackedBorderStyle)

    let rowUserPalette = HtmlUtil.createElement("div", {elementClass: ["ColorContent"]});
    let userPalette = HtmlUtil.createElement("select", {name: "userPalette", id: "userPalette"});
    let buttonDeleteColor = HtmlUtil.createElement("button", {elementClass: ["buttonDeleteColor", "button"], id: "buttonDeleteColor", text: game.i18n.localize("MI.colorContent.deleteColor")});
    let divPackedUserPalette = HtmlUtil.toDivPack([userPalette, buttonDeleteColor]);
    HtmlUtil.appendElements(rowUserPalette, divPackedUserPalette);

    HtmlUtil.appendElements(colorContent, [
        row, 
        divColorHex,
        rowNameColor,
        rowButtonColor,
        rowBorderStyle,
        rowUserPalette
    ]);
    
    return colorContent.outerHTML;
}

// colorContent = `
//             <div class="ColorContent">
//                 <div class="ColorContentRow">
//                     <div><label for="colour">${game.i18n.localize("MI.colorContent.color")}:</label></div>
//                     <div><input type="color" id="colour" name="color" value="#ffffff"></div>
//                     <div><label for="transparent">${game.i18n.localize("MI.colorContent.transparent")}:</label></div>
//                     <div><input type="range" id="transparent" name="transparent" min="0" max="1" value="1" step="0.01" /></div>
//                 </div>
//                 <div><input type="text" id="colorHex" name="colorHex" value="#ffffff"></div>
//                 <div class="ColorContentRow">
//                     <div><input id="nameColor" type="text"></div>
//                     <div data="button"><button id="buttonColorAdd" class="buttonColorAdd button">${game.i18n.localize("MI.colorContent.save")}</button></div>
//                 </div>
//                 <div class="ColorContentRow">
//                     <div data="button"><button id="buttonColor" class="buttonColor button">${game.i18n.localize("MI.colorContent.setColourText")}</button></div>
//                     <div data="button"><button id="buttonColorBackground" class="buttonColorBackground button">${game.i18n.localize("MI.colorContent.setColourBorder")}</button></div>
//                 </div>
//                 <div class="ColorContentRow">
//                     <div>
//                         <select id="userPalette" name="userPalette">
//                         </select>
//                     </div>
//                     <div data="button"><button id="buttonDeleteColor" class="buttonDeleteColor button">${game.i18n.localize("MI.colorContent.deleteColor")}</button></div>
//                 </div>
//             </div>
//     `