import { HtmlUtil } from "../htmlUtil.js";

export function createLinksTab(){
    let tab = HtmlUtil.createElement("div", { elementClass: ["linksContent"] });
    let row = HtmlUtil.createElement("div", { elementClass: ["linksContentRow"] });
    tab.appendChild(row);
    let divRefreshCompendiumButton = HtmlUtil.createElement("div", { elementClass: ["divButton"] });
    let refreshCompendiumButton = HtmlUtil.createElement("button", {elementClass: ["refreshCompendiumButton", "button"], id: "refreshCompendiumButton", text: game.i18n.localize("MI.linksContent.refreshCompendiumButton")});
    divRefreshCompendiumButton.appendChild(refreshCompendiumButton);
    let divCheckboxes = document.createElement("div");
    let labelEmbedValueLinks = HtmlUtil.createElement("label", {for: "EmbedValueLinks", text: game.i18n.localize("MI.linksContent.embed")});
    let embedValueLinks = HtmlUtil.createElement("input", { elementClass: ["EmbedValueLinks"], type: "checkbox", name: "EmbedValueLinks"});

    let labelEmptyValueLinks = HtmlUtil.createElement("label", {for: "emptyValueLinks", text: game.i18n.localize("MI.referenseContent.emptyValue")});
    let emptyValueLinks = HtmlUtil.createElement("input", { elementClass: ["emptyValueLinks"], type: "checkbox", name: "emptyValueLinks"});

    let labelLikeAKikimor = HtmlUtil.createElement("label", {for: "likeAKikimor", text: game.i18n.localize("MI.linksContent.likeAKikimor")});
    let likeAKikimor = HtmlUtil.createElement("input", { elementClass: ["likeAKikimor"], type: "checkbox", name: "likeAKikimor"});
    HtmlUtil.appendElements(divCheckboxes, [
        labelEmbedValueLinks, 
        embedValueLinks, 
        labelEmptyValueLinks, 
        emptyValueLinks, 
        labelLikeAKikimor, 
        likeAKikimor
    ]);
    let divCustomName = document.createElement("div");
    let customName = HtmlUtil.createElement("input",  {type: "text", name: "customName", placeholder: game.i18n.localize("MI.linksContent.placeholder")});
    divCustomName.appendChild(customName);

    let divActorsSelect = document.createElement("div");
    let labelActorsSelect = HtmlUtil.createElement("label", {for: "actorsSelect", text: game.i18n.localize("MI.linksContent.compendiumCreature")});
    let actorsSelect = HtmlUtil.createElement("select", { name: "actorsSelect", size: "5", multiple: "true", data_tooltip: game.i18n.localize("MI.linksContent.tooltip"), data_tooltip_direction: "BOTTOM" });
    HtmlUtil.appendElements(divActorsSelect, [
        labelActorsSelect, 
        actorsSelect
    ]);

    let divItemsSelect = document.createElement("div");
    let labelItemsSelect = HtmlUtil.createElement("label", {for: "itemsSelect", text: game.i18n.localize("MI.linksContent.compendiumItem")});
    let itemsSelect = HtmlUtil.createElement("select", { name: "itemsSelect", size: "5", multiple: "true", data_tooltip: game.i18n.localize("MI.linksContent.tooltip"), data_tooltip_direction: "BOTTOM" });
    HtmlUtil.appendElements(divItemsSelect, [
        labelItemsSelect, 
        itemsSelect
    ]);

    let divCreatureButton = HtmlUtil.createElement("div");
    let creatureButton = HtmlUtil.createElement("button", {elementClass: ["creatureButton", "button"], id: "creatureButton", text: game.i18n.localize("MI.linksContent.creature")});
    divCreatureButton.appendChild(creatureButton)

    let divItemButton = HtmlUtil.createElement("div");
    let itemButton = HtmlUtil.createElement("button", {elementClass: ["itemButton", "button"], id: "itemButton", text: game.i18n.localize("MI.linksContent.item")});
    divItemButton.appendChild(itemButton)

    let divRollTableSelect = document.createElement("div");
    let labelRollTableSelect = HtmlUtil.createElement("label", {for: "rollTableSelect", text: game.i18n.localize("MI.linksContent.rollTable")});
    let rollTableSelect = HtmlUtil.createElement("select", { name: "rollTableSelect", size: "5", multiple: "true", data_tooltip: game.i18n.localize("MI.linksContent.tooltip"), data_tooltip_direction: "BOTTOM" });
    HtmlUtil.appendElements(divRollTableSelect, [
        labelRollTableSelect, 
        rollTableSelect
    ]);

    let divJournalEntrySelect = document.createElement("div");
    let labelJournalEntrySelect = HtmlUtil.createElement("label", {for: "journalEntrySelect", text: game.i18n.localize("MI.linksContent.journalEntry")});
    let journalEntrySelect = HtmlUtil.createElement("select", { name: "journalEntrySelect", size: "5", multiple: "true", data_tooltip: game.i18n.localize("MI.linksContent.tooltip"), data_tooltip_direction: "BOTTOM" });
    HtmlUtil.appendElements(divJournalEntrySelect, [
        labelJournalEntrySelect, 
        journalEntrySelect
    ]);

    let divRollTableButton = HtmlUtil.createElement("div");
    let rollTableButton = HtmlUtil.createElement("button", {elementClass: ["rollTableButton", "button"], id: "rollTableButton", text: game.i18n.localize("MI.linksContent.rollTableButton")});
    divRollTableButton.appendChild(rollTableButton)

    let divJournalEntryButton = HtmlUtil.createElement("div");
    let journalEntryButton = HtmlUtil.createElement("button", {elementClass: ["journalEntryButton", "button"], id: "journalEntryButton", text: game.i18n.localize("MI.linksContent.journalEntryButton")});
    divJournalEntryButton.appendChild(journalEntryButton)

    let divMacroSelect = document.createElement("div");
    let labelMacroSelect = HtmlUtil.createElement("label", {for: "macroSelect", text: game.i18n.localize("MI.linksContent.macro")});
    let macroSelect = HtmlUtil.createElement("select", { name: "macroSelect", size: "5", multiple: "true", data_tooltip: game.i18n.localize("MI.linksContent.tooltip"), data_tooltip_direction: "BOTTOM" });
    HtmlUtil.appendElements(divMacroSelect, [
        labelMacroSelect, 
        macroSelect
    ]);

    let divSceneSelect = document.createElement("div");
    let labelSceneSelect = HtmlUtil.createElement("label", {for: "sceneSelect", text: game.i18n.localize("MI.linksContent.sceneSelect")});
    let sceneSelect = HtmlUtil.createElement("select", { name: "sceneSelect", size: "5", multiple: "true", data_tooltip: game.i18n.localize("MI.linksContent.tooltip"), data_tooltip_direction: "BOTTOM" });
    HtmlUtil.appendElements(divSceneSelect, [
        labelSceneSelect, 
        sceneSelect
    ]);

    let divMacroSelectButton = HtmlUtil.createElement("div");
    let macroSelectButton = HtmlUtil.createElement("button", {elementClass: ["macroSelectButton", "button"], id: "macroSelectButton", text: game.i18n.localize("MI.linksContent.macroSelectButton")});
    divMacroSelectButton.appendChild(macroSelectButton)

    let divSceneButton = HtmlUtil.createElement("div");
    let sceneButton = HtmlUtil.createElement("button", {elementClass: ["sceneButton", "button"], id: "sceneButton", text: game.i18n.localize("MI.linksContent.sceneButton")});
    divSceneButton.appendChild(sceneButton)

  

    HtmlUtil.appendElements(row, [
        divRefreshCompendiumButton, 
        divCheckboxes,
        divCustomName,
        divActorsSelect,
        divItemsSelect,
        divCreatureButton,
        divItemButton,
        divRollTableSelect,
        divJournalEntrySelect,
        divRollTableButton,
        divJournalEntryButton,
        divMacroSelect,
        divSceneSelect,
        divMacroSelectButton,
        divSceneButton
        
    ]);

    return tab.outerHTML;
} 


//rollTableSelect, journalEntrySelect, macroSelect, sceneSelect