import { HtmlUtil } from "../htmlUtil.js";
import { moduleName } from "../settings.js";

export function createPicturesContent(){
    let picturesContent = HtmlUtil.createElement("div", {elementClass: ["pictures_controls"]});
    let pictures_controls_data = HtmlUtil.createElement("div", {elementClass: ["pictures_controls_data"]});

    let leftCheck = document.createElement("div");
    let inputLeftCheck = HtmlUtil.createElement("input", {id: "leftCheck", name: "leftCheck", type: "checkbox"});
    let labelLeftCheck = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.leftCheck")});
    let onCircle = document.createElement("div");
    let inputOnCircle = HtmlUtil.createElement("input", {id: "onCircle", name: "onCircle", type: "checkbox"});
    let labelOnCircle =  HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.onCircle")});
    let rightCheck = document.createElement("div");
    let inputRightCheck = HtmlUtil.createElement("input", {id: "rightCheck", name: "rightCheck", type: "checkbox"});
    let labelRightCheck = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.rightCheck")});

    let scalePic = HtmlUtil.createElement("div", {elementClass: ["scalePic"]});
    
    let labelScalePic = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.scale")});
    let scaleDivlabel = HtmlUtil.createElement("div", {data: "data"});
    scaleDivlabel.appendChild(labelScalePic);

    let scaleSelectPic = HtmlUtil.createElement("select", {id: "scale", name: "scale"});
    let _options = {"one": "X1", "two": "X2", "three": "X3"};

    for (let [key, val] of Object.entries(_options)){
        let option = HtmlUtil.createElement("option", {value: key,text: val});
        scaleSelectPic.appendChild(option);
    }

    let scaleDivSelect = HtmlUtil.createElement("div", {data: "data"});
    scaleDivSelect.appendChild(scaleSelectPic);
    HtmlUtil.appendElements(scalePic, [scaleDivlabel, scaleDivSelect]);

    let refImg = HtmlUtil.createElement("img", {id: "refImg", name: "refImg" ,src: "icons/vtt-512.png"});

    let refImgDiv = HtmlUtil.createElement("div", {elementClass: ["refImg"]});
    let figure = HtmlUtil.createElement("figure");
    figure.appendChild(refImg);
    refImgDiv.appendChild(figure);

    let pictureAbsoluteSize = HtmlUtil.createElement("div", {elementClass: ["picturesAbsoluteSize"]});
    let labelHeight = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.height")});
    let height = HtmlUtil.createElement("input", {elementClass: ["heightPic"], name: "heightPic", type: "number", value: ""});
    let divHeight = HtmlUtil.createElement("div");
    let labelWidth = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.width")});
    let width = HtmlUtil.createElement("input", {elementClass: ["widthPic"], name: "widthPic", type: "number", value: ""});
    let divWidth = HtmlUtil.createElement("div");
    HtmlUtil.appendElements(divHeight, [labelHeight, height]);
    HtmlUtil.appendElements(divWidth, [labelWidth, width]);

    HtmlUtil.appendElements(pictureAbsoluteSize, [divWidth, divHeight]);

    let picturesInput = HtmlUtil.createElement("input", {elementClass: ["picturesInput"], id: "picturesInput", name: "picturesInput", type: "text" ,value: "icons/vtt-512.png"});
    
    let picturesInputDiv = HtmlUtil.createElement("div", {elementClass: ["picturesInputContainer"]});
    picturesInputDiv.appendChild(picturesInput);

    let buttonPictures = HtmlUtil.createElement("button", {elementClass: ["buttonAddPictures", "button"], id: "addPictures" , text: game.i18n.localize("MI.pictureAndDesignMenu.InsertPicture")});
    let divAddPictures = HtmlUtil.createElement("div", {data: "data"});
    divAddPictures.appendChild(buttonPictures);

    let buttonNarrative = HtmlUtil.createElement("button", {elementClass: ["buttonNarrative", "button"], id: "narrative", text: game.i18n.localize("MI.pictureAndDesignMenu.narrative")});
    let divNarrative = HtmlUtil.createElement("div", {data: "data"});
    divNarrative.appendChild(buttonNarrative);

    let buttonAdvice = HtmlUtil.createElement("button", {elementClass: ["buttonAdvice", "button"], id: "advice"});
    let butImg = HtmlUtil.createElement("img", {id: "butImg", name: "butImg", src: (game.user.getFlag(moduleName, "picturePath") !== undefined) ? game.user.getFlag(moduleName, "picturePath") : "icons/vtt-512.png"});
    let butImgP = HtmlUtil.createElement("p");
    let textP = HtmlUtil.createElement("p", {text: game.i18n.localize("MI.pictureAndDesignMenu.advice")});
    butImgP.appendChild(butImg);
    HtmlUtil.appendElements(buttonAdvice, [butImgP, textP]);
    let divAdvice = HtmlUtil.createElement("div", {data: "data"});
    divAdvice.appendChild(buttonAdvice);

    let buttonNotable = HtmlUtil.createElement("button", {elementClass: ["buttonNotable", "button"], id: "notable", text: game.i18n.localize("MI.pictureAndDesignMenu.notable")});
    let divNotable = HtmlUtil.createElement("div", {data: "data"});
    divNotable.appendChild(buttonNotable);

    HtmlUtil.appendElements(leftCheck, [inputLeftCheck, labelLeftCheck]);
    HtmlUtil.appendElements(onCircle, [inputOnCircle, labelOnCircle]);
    HtmlUtil.appendElements(rightCheck, [inputRightCheck, labelRightCheck]);

    
    let divsControls = [leftCheck, onCircle, rightCheck, scalePic, refImgDiv, pictureAbsoluteSize, picturesInputDiv, divAddPictures, divNarrative, divAdvice, divNotable];
    HtmlUtil.appendElements(pictures_controls_data, divsControls);

    picturesContent.appendChild(pictures_controls_data);
    return picturesContent.outerHTML;
}