import { HtmlUtil } from "../htmlUtil.js";

export function createReferenseContentTabs(){
    let referenseContentTabs = HtmlUtil.createElement("div", {elementClass: ["referenseContentTabs"]});
    let bold = HtmlUtil.createElement("b");
    let tabs = {
        "tab1": game.i18n.localize("MI.referenseContent.ability"),
        "tab2": game.i18n.localize("MI.referenseContent.skill"),
        "tab3": game.i18n.localize("MI.referenseContent.condition"),
        "tab4": game.i18n.localize("MI.referenseContent.creatureType"),
        "tab5": game.i18n.localize("MI.referenseContent.typeDamage"),
        "tab6": game.i18n.localize("MI.referenseContent.tool"),
        "tab7": game.i18n.localize("MI.referenseContent.areaOfEffect"),
        "tab8": game.i18n.localize("MI.referenseContent.component"),
        "tab9": game.i18n.localize("MI.referenseContent.spellSchool"),
        "tab10": game.i18n.localize("MI.referenseContent.rules")
    };
    let navigation = HtmlUtil.createElement("nav", {elementClass: ["referenseTabs"], data_group: "referense-tabs"});
    let referenseTabsContainer = HtmlUtil.createElement("div", {elementClass: ["referenseTabsContainer"]});
    for (let [tab, text] of Object.entries(tabs)){
        let a = HtmlUtil.createElement("button", {elementClass: ["itemRef"], data_tab: tab, text: `<div>${text}</div>`});
        let div = HtmlUtil.createElement("div");
        div.appendChild(a);
        referenseTabsContainer.appendChild(div);
    }
    navigation.appendChild(referenseTabsContainer);
    bold.appendChild(navigation);
    let br1 = HtmlUtil.createElement("br")

    let contentRefInput = setContentRefInput();

    let br2 = HtmlUtil.createElement("br")

    //section
    let sectionContentRef = HtmlUtil.createElement("section", {elementClass: ["contentRef"]});

    //ability
    let divContentabilit = getAbilityTab()
    //skill
    let divContentskill = getSkillTab()
    //condition
    let divContentabiCondition = getConditionTab()
    //creature type
    let divContentabiCreatureType = getCreatureTypeTab()
    //damage type
    let divContentabiTypeDamage = getTypeDamageTab()
    //tool
    let divContentabitoolsList = getToolTab()
    //areaOfEffect
    let divContentAreaOfEffect = getAreaOfEffectTab()
    //component
    let divContentComponent = getComponentTab()
    //spell school
    let divContentspellSchool = getSpellSchoolTab()
    //rules
    let divContentabirules = getRulesTab()

    HtmlUtil.appendElements(sectionContentRef, [
        divContentabilit, 
        divContentskill, 
        divContentabiCondition, 
        divContentabiCreatureType, 
        divContentabiTypeDamage, 
        divContentabitoolsList,
        divContentAreaOfEffect,
        divContentComponent,
        divContentspellSchool,
        divContentabirules
    ]);
    HtmlUtil.appendElements(referenseContentTabs, [bold, br1, contentRefInput, br2, sectionContentRef]);
    return referenseContentTabs.outerHTML;
}

function setContentRefInput(){
    let contentRefInput = HtmlUtil.createElement("div", {elementClass: ["contentRefInput"]});
    let cheks = [
        [
            {element: "div", args: {elementClass: ["numberCheck"]}},
            {element: "input", args: {id: "numberCheck", name: "numberCheck", type: "checkbox"}},
            {element: "label", args: {text: game.i18n.localize("MI.referenseContent.ModifierFromText")}},
        ],
        [
            {element: "div", args: {elementClass: ["NullCheck"]}},
            {element: "input", args: {id: "NullCheck", type: "checkbox"}},
            {element: "label", args: {text: game.i18n.localize("MI.referenseContent.emptyValue")}},
        ],
        [
            {element: "div", args: {elementClass: ["skillPassiveCheck"]}},
            {element: "input", args: {id: "skillPassiveCheck", type: "checkbox"}},
            {element: "label", args: {text: game.i18n.localize("MI.referenseContent.skillList.passiveCheck")}},
        ],
        [
            {element: "div", args: {elementClass: ["damageFormula"]}},
            {element: "label", args: {text: game.i18n.localize("MI.referenseContent.damageFormula")}},
            {element: "input", args: {id: "damageFormula", type: "text"}},
        ],
        [
            {element: "div", args: {elementClass: ["numberForMod"]}},
            {element: "label", args: {text: game.i18n.localize("MI.referenseContent.Modifier")}},
            {element: "input", args: {id: "numberForMod", type: "number"}},
        ]
    ];
    for (let elements of cheks){
        const div = HtmlUtil.createElement(elements[0].element, elements[0].args);
        const div2 = HtmlUtil.createElement(elements[0].element, elements[0].args);
        const divs = [div, div2];
        for (let i = 1; i < elements.length; i++){
            divs[i-1].appendChild(HtmlUtil.createElement(elements[i].element, elements[i].args));
        }
        HtmlUtil.appendElements(contentRefInput, divs);
    }
    return contentRefInput
}

function getAbilityTab(){
    let divContentabilit = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab1", data_group: "referense-tabs"});
    let abilityOptions = {
        "strength": game.i18n.localize("MI.referenseContent.abilityList.strength"),
        "dexterity": game.i18n.localize("MI.referenseContent.abilityList.dexterity"),
        "constitution": game.i18n.localize("MI.referenseContent.abilityList.constitution"),
        "intelligence": game.i18n.localize("MI.referenseContent.abilityList.intelligence"),
        "wisdom": game.i18n.localize("MI.referenseContent.abilityList.wisdom"),
        "charisma": game.i18n.localize("MI.referenseContent.abilityList.charisma")
    };
    let abilityContainer = HtmlUtil.createElement("div", {elementClass: ["abilityContainer"]});
    let labelAbility = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.referenseContent.abilityList.savingThrow")});
    let inputAbilityCheck = HtmlUtil.createElement("input", {id: "abilityCheck", name: "abilityCheck", type: "checkbox"});

    let labelSelectAbility = HtmlUtil.createElement("label", {for: "ability", text: game.i18n.localize("MI.referenseContent.ability")});
    let selectAbility = HtmlUtil.createElement("select", {id: "ability", name: "ability"});
    let sorted = HtmlUtil.sortDict(abilityOptions);
    for (let [key, value] of Object.entries(sorted)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        selectAbility.appendChild(option);
    }
    let buttonAbilityContainer = HtmlUtil.createElement("div", {elementClass: ["buttonAbilityContainer"]});
    let buttonAbility = HtmlUtil.createElement("button", {elementClass: ["buttonAbility", "button"], id: "buttonAbility", text: game.i18n.localize("MI.referenseContent.abilityList.setAbility")});
    buttonAbilityContainer.appendChild(buttonAbility);
    let divPackedAbility = HtmlUtil.toDivPack([labelAbility, inputAbilityCheck, labelSelectAbility, selectAbility]);
    HtmlUtil.appendElements(abilityContainer, divPackedAbility);
    abilityContainer.appendChild(buttonAbilityContainer);
    divContentabilit.appendChild(abilityContainer);
    return divContentabilit;
}

function getSkillTab(){
    let divContentskill = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab2", data_group: "referense-tabs"});
    let skillContainer = HtmlUtil.createElement("div", {elementClass: ["skillContainer"]});
    let skillOptions = {
        "acrobatics": game.i18n.localize("MI.referenseContent.skillList.acrobatics"),
        "animalHandling": game.i18n.localize("MI.referenseContent.skillList.animalHandling"),
        "arcana": game.i18n.localize("MI.referenseContent.skillList.arcana"),
        "athletics": game.i18n.localize("MI.referenseContent.skillList.athletics"),
        "deception": game.i18n.localize("MI.referenseContent.skillList.deception"),
        "history": game.i18n.localize("MI.referenseContent.skillList.history"),
        "insight": game.i18n.localize("MI.referenseContent.skillList.insight"),
        "intimidation": game.i18n.localize("MI.referenseContent.skillList.intimidation"),
        "investigation": game.i18n.localize("MI.referenseContent.skillList.investigation"),
        "medicine": game.i18n.localize("MI.referenseContent.skillList.medicine"),
        "nature": game.i18n.localize("MI.referenseContent.skillList.nature"),
        "perception": game.i18n.localize("MI.referenseContent.skillList.perception"),
        "performance": game.i18n.localize("MI.referenseContent.skillList.performance"),
        "persuasion": game.i18n.localize("MI.referenseContent.skillList.persuasion"),
        "religion": game.i18n.localize("MI.referenseContent.skillList.religion"),
        "sleightOfHand": game.i18n.localize("MI.referenseContent.skillList.sleightOfHand"),
        "stealth": game.i18n.localize("MI.referenseContent.skillList.stealth"),
        "survival": game.i18n.localize("MI.referenseContent.skillList.survival"),
    };
    let labelSkill = HtmlUtil.createElement("label", {for: "skill", text: game.i18n.localize("MI.referenseContent.skill")});
    let selectSkill = HtmlUtil.createElement("select", {id: "skill", name: "skill"});
    let sortedSkill = HtmlUtil.sortDict(skillOptions);
    for(let key in sortedSkill){
        let option = HtmlUtil.createElement("option", {value: key, text: sortedSkill[key]});
        selectSkill.appendChild(option);
    }
    let divPackedSkill = HtmlUtil.toDivPack([labelSkill, selectSkill]);
    HtmlUtil.appendElements(skillContainer, divPackedSkill);
    let buttonSkillContainer = HtmlUtil.createElement("div", {elementClass: ["buttonSkillContainer"]});
    let buttonSkill = HtmlUtil.createElement("button", {elementClass: ["buttonSkill", "button"],id: "buttonSkill", text: game.i18n.localize("MI.referenseContent.skillList.setSkill")});
    buttonSkillContainer.appendChild(buttonSkill);
    skillContainer.appendChild(buttonSkillContainer);
    divContentskill.appendChild(skillContainer);
    return divContentskill;
}

function getConditionTab(){
    let divContentabiCondition = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab3", data_group: "referense-tabs"});
    let conditionOptions = {
        "blinded": game.i18n.localize("MI.referenseContent.conditionList.blinded"),
        "charmed": game.i18n.localize("MI.referenseContent.conditionList.charmed"),
        "deafened": game.i18n.localize("MI.referenseContent.conditionList.deafened"),
        "exhaustion": game.i18n.localize("MI.referenseContent.conditionList.exhaustion"),
        "frightened": game.i18n.localize("MI.referenseContent.conditionList.frightened"),
        "grappled": game.i18n.localize("MI.referenseContent.conditionList.grappled"),
        "incapacitated": game.i18n.localize("MI.referenseContent.conditionList.incapacitated"),
        "invisible": game.i18n.localize("MI.referenseContent.conditionList.invisible"),
        "paralyzed": game.i18n.localize("MI.referenseContent.conditionList.paralyzed"),
        "petrified": game.i18n.localize("MI.referenseContent.conditionList.petrified"),
        "poisoned": game.i18n.localize("MI.referenseContent.conditionList.poisoned"),
        "prone": game.i18n.localize("MI.referenseContent.conditionList.prone"),
        "restrained": game.i18n.localize("MI.referenseContent.conditionList.restrained"),
        "stunned": game.i18n.localize("MI.referenseContent.conditionList.stunned"),
        "unconscious": game.i18n.localize("MI.referenseContent.conditionList.unconscious")
    };
    let conditionContainer = HtmlUtil.createElement("div", {elementClass: ["conditionContainer"]});
    let labelCondition = HtmlUtil.createElement("label", {for: "condition", text: game.i18n.localize("MI.referenseContent.condition")});
    let selectCondition = HtmlUtil.createElement("select", {id: "condition", name: "condition"});
    let ConditionsSorted = HtmlUtil.sortDict(conditionOptions);
    for (let [key, value] of Object.entries(ConditionsSorted)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        selectCondition.appendChild(option);
    }
    let buttonConditionContainer =  HtmlUtil.createElement("div", {elementClass: ["buttonConditionContainer"]});
    let buttonCondition = HtmlUtil.createElement("button", {elementClass: ["buttonCondition", "button"], id: "buttonCondition", text: game.i18n.localize("MI.referenseContent.conditionList.setCondition")});
    let conditionDivPacked = HtmlUtil.toDivPack([labelCondition, selectCondition])
    buttonConditionContainer.appendChild(buttonCondition);
    conditionDivPacked.push(buttonConditionContainer);
    HtmlUtil.appendElements(conditionContainer, conditionDivPacked);
    divContentabiCondition.appendChild(conditionContainer);
    return divContentabiCondition;
}

function getCreatureTypeTab(){
    let divContentabiCreatureType = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab4", data_group: "referense-tabs"});
    let creatureTypeOptions = {
        "aberration": game.i18n.localize("MI.referenseContent.creatureTypeList.aberration"),
        "beast": game.i18n.localize("MI.referenseContent.creatureTypeList.beast"),
        "celestial": game.i18n.localize("MI.referenseContent.creatureTypeList.celestial"),
        "construct": game.i18n.localize("MI.referenseContent.creatureTypeList.construct"),
        "dragon": game.i18n.localize("MI.referenseContent.creatureTypeList.dragon"),
        "elemental": game.i18n.localize("MI.referenseContent.creatureTypeList.elemental"),
        "fey": game.i18n.localize("MI.referenseContent.creatureTypeList.fey"),
        "fiend": game.i18n.localize("MI.referenseContent.creatureTypeList.fiend"),
        "giant": game.i18n.localize("MI.referenseContent.creatureTypeList.giant"),
        "humanoid": game.i18n.localize("MI.referenseContent.creatureTypeList.humanoid"),
        "monstrosity": game.i18n.localize("MI.referenseContent.creatureTypeList.monstrosity"),
        "ooze": game.i18n.localize("MI.referenseContent.creatureTypeList.ooze"),
        "plant": game.i18n.localize("MI.referenseContent.creatureTypeList.plant"),
        "undead": game.i18n.localize("MI.referenseContent.creatureTypeList.undead")
    }
    let creatureTypeContainer = HtmlUtil.createElement("div", {elementClass: ["creatureTypeContainer"]});
    let labelCreatureType = HtmlUtil.createElement("label", {for: "creatureType", text: game.i18n.localize("MI.referenseContent.creatureType")});
    let creatureTypeSelect = HtmlUtil.createElement("select", {id: "creatureType", name: "creatureType"});
    let creatureTypeSorted = HtmlUtil.sortDict(creatureTypeOptions);
    for (let [key, value] of Object.entries(creatureTypeSorted)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        creatureTypeSelect.appendChild(option);
    }
    let buttonCreatureTypeContainer = HtmlUtil.createElement("div", {elementClass: ["buttonCreatureTypeContainer"]});
    let buttonCreatureType = HtmlUtil.createElement("button", {elementClass: ["buttonCreatureType", "button"], id: "buttonCreatureType", text: game.i18n.localize("MI.referenseContent.creatureTypeList.setCreatureType")});
    let creatureTypeDivPaked = HtmlUtil.toDivPack([labelCreatureType, creatureTypeSelect]);
    buttonCreatureTypeContainer.appendChild(buttonCreatureType);
    creatureTypeDivPaked.push(buttonCreatureTypeContainer);
    HtmlUtil.appendElements(creatureTypeContainer, creatureTypeDivPaked);
    divContentabiCreatureType.appendChild(creatureTypeContainer);
    return divContentabiCreatureType;
}

function getTypeDamageTab(){
    let divContentabiTypeDamage = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab5", data_group: "referense-tabs"});
    let divContentabiTypeDamageContainer = HtmlUtil.createElement("div", {elementClass: ["typeDamageContainer"]});
    let divContentabiTypeDamageAverageContainer = HtmlUtil.createElement("div", {elementClass: ["averageContainer"]});
    let labelDamageAverage = HtmlUtil.createElement("label", {for: "average", text: game.i18n.localize("MI.referenseContent.average")});
    let inputDamageAverage = HtmlUtil.createElement("input", {id: "average", type: "checkbox"});
    let inputDamageAverageNumber = HtmlUtil.createElement("input", {id: "numberAverage", type: "number"});
    let AverageDivPacked = HtmlUtil.toDivPack([labelDamageAverage, inputDamageAverage, inputDamageAverageNumber]);
    HtmlUtil.appendElements(divContentabiTypeDamageAverageContainer, AverageDivPacked);
    divContentabiTypeDamageContainer.appendChild(divContentabiTypeDamageAverageContainer)
    let typeDamageOptions = {
        "acid": game.i18n.localize("MI.referenseContent.typeDamageList.acid"),
        "bludgeoning": game.i18n.localize("MI.referenseContent.typeDamageList.bludgeoning"),
        "cold": game.i18n.localize("MI.referenseContent.typeDamageList.cold"),
        "fire": game.i18n.localize("MI.referenseContent.typeDamageList.fire"),
        "force": game.i18n.localize("MI.referenseContent.typeDamageList.force"),
        "lightning": game.i18n.localize("MI.referenseContent.typeDamageList.lightning"),
        "necrotic": game.i18n.localize("MI.referenseContent.typeDamageList.necrotic"),
        "piercing": game.i18n.localize("MI.referenseContent.typeDamageList.piercing"),
        "poison": game.i18n.localize("MI.referenseContent.typeDamageList.poison"),
        "psychic": game.i18n.localize("MI.referenseContent.typeDamageList.psychic"),
        "radiant": game.i18n.localize("MI.referenseContent.typeDamageList.radiant"),
        "slashing": game.i18n.localize("MI.referenseContent.typeDamageList.slashing"),
        "thunder": game.i18n.localize("MI.referenseContent.typeDamageList.thunder"),
        "healing": game.i18n.localize("MI.referenseContent.typeDamageList.healing"),
        "temphp": game.i18n.localize("MI.referenseContent.typeDamageList.temphp")
    };

    let typeDamageOptionsSorted = HtmlUtil.sortDict(typeDamageOptions);
    let labelTypeDamage = HtmlUtil.createElement("label", {for: "typeDamage", text: game.i18n.localize("MI.referenseContent.typeDamage")});
    let selectTypeDamage = HtmlUtil.createElement("select", {id: "typeDamage", name: "typeDamage"});
    selectTypeDamage.appendChild(HtmlUtil.createElement("option", {value: "noType", text: game.i18n.localize("MI.referenseContent.typeDamageList.noType")}));
    selectTypeDamage.appendChild(HtmlUtil.createElement("option", {value: "roll", text: game.i18n.localize("MI.referenseContent.typeDamageList.roll")}));
    for (let key in typeDamageOptionsSorted) {
        let option = HtmlUtil.createElement("option", {value: key, text: typeDamageOptionsSorted[key]});
        selectTypeDamage.appendChild(option);
    }
    let buttonTypeDamageContainer = HtmlUtil.createElement("div", {elementClass: ["buttonTypeDamageContainer"]});
    let buttonTypeDamage = HtmlUtil.createElement("button", {elementClass: ["buttonTypeDamage","button"], id: "buttonTypeDamage", text: game.i18n.localize("MI.referenseContent.typeDamageList.setDamageType")});
    let TypeDamageDivPacked = HtmlUtil.toDivPack([labelTypeDamage, selectTypeDamage]);
    buttonTypeDamageContainer.appendChild(buttonTypeDamage);
    TypeDamageDivPacked.push(buttonTypeDamageContainer);
    HtmlUtil.appendElements(divContentabiTypeDamageContainer, TypeDamageDivPacked)
    divContentabiTypeDamage.appendChild(divContentabiTypeDamageContainer);
    return divContentabiTypeDamage;
}

function getToolTab(){
    let divContentabitoolsList = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab6", data_group: "referense-tabs"});
    let divToolsContainer = HtmlUtil.createElement("div", {elementClass: ["ToolsContainer"]});
    let toolOptions = [
        "alchemist", "bagpipes", "brewer", "calligrapher",
        "card", "carpenter", "cartographer", "chess",
        "cobbler", "cook", "dice", "disg",
        "dulcimer", "flute", "forg", "glassblower",
        "herb", "horn", "leatherworker", "lute",
        "lyre", "mason", "navg", "painter",
        "panflute", "pois", "potter", "shawm",
        "smith", "thief", "tinker", "viol",
        "weaver", "woodcarver"
    ];
    let toolOptionsDict = {};
    for (let tool of toolOptions) {
        toolOptionsDict[tool] = game.i18n.localize(`MI.referenseContent.toolsList.${tool}`);
    };
    toolOptions = HtmlUtil.sortDict(toolOptionsDict);
    let abilityOptions = {
        "strength": game.i18n.localize("MI.referenseContent.abilityList.strength"),
        "dexterity": game.i18n.localize("MI.referenseContent.abilityList.dexterity"),
        "constitution": game.i18n.localize("MI.referenseContent.abilityList.constitution"),
        "intelligence": game.i18n.localize("MI.referenseContent.abilityList.intelligence"),
        "wisdom": game.i18n.localize("MI.referenseContent.abilityList.wisdom"),
        "charisma": game.i18n.localize("MI.referenseContent.abilityList.charisma")
    }
    let abilitySorted = HtmlUtil.sortDict(abilityOptions);
    let toolSelect = HtmlUtil.createElement("select", {id:"Tool", name:"Tool"});
    for (let [key, value] of Object.entries(toolOptions)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        toolSelect.appendChild(option);
    }
    let abilitySelect = HtmlUtil.createElement("select", {id:"abilityTool", name:"abilitTooly"});
    for (let [key, value] of Object.entries(abilitySorted)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        abilitySelect.appendChild(option);
    }
    let buttonToolContainer = HtmlUtil.createElement("div", {elementClass: ["buttonToolContainer"]});
    let buttonTool = HtmlUtil.createElement("button", {elementClass: ["buttonTool", "button"], id:"buttonTool", name: "buttonTool", text: game.i18n.localize("MI.referenseContent.toolsList.setTool")});
    buttonToolContainer.appendChild(buttonTool);
    HtmlUtil.appendElements(divToolsContainer, HtmlUtil.toDivPack([toolSelect, abilitySelect]));
    divToolsContainer.appendChild(buttonToolContainer);
    divContentabitoolsList.appendChild(divToolsContainer);
    return divContentabitoolsList;
}

function getAreaOfEffectTab(){
    let divContentAreaOfEffect = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab7", data_group: "referense-tabs"});
    let areaOfEffectContainer = HtmlUtil.createElement("div", {elementClass: ["areaOfEffectContainer"]});
    let labelAreaOfEffect = HtmlUtil.createElement("label", {for: "areaOfEffect", text: game.i18n.localize("MI.referenseContent.areaOfEffect")});
    let selectAreaOfEffect = HtmlUtil.createElement("select", {id: "areaOfEffect", name: "areaOfEffect"});
    let areaOfEffectOption ={
        "cone": game.i18n.localize("MI.referenseContent.areaOfEffectList.cone"),
        "cube": game.i18n.localize("MI.referenseContent.areaOfEffectList.cube"),
        "sphere": game.i18n.localize("MI.referenseContent.areaOfEffectList.sphere"),
        "square": game.i18n.localize("MI.referenseContent.areaOfEffectList.square"),
        "line": game.i18n.localize("MI.referenseContent.areaOfEffectList.line")
    };
    let sortedAreaOfEffectOption = HtmlUtil.sortDict(areaOfEffectOption);
    for (let [key, value] of Object.entries(sortedAreaOfEffectOption)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        selectAreaOfEffect.appendChild(option);
    }
    let buttonAreaOfEffectContainer = HtmlUtil.createElement("div", {elementClass: ["buttonAreaOfEffectContainer"]});
    let buttonAreaOfEffect = HtmlUtil.createElement("button", {elementClass: ["buttonAreaOfEffect", "button"], id: "buttonAreaOfEffect", text: game.i18n.localize("MI.referenseContent.areaOfEffectList.setAreaOfEffect")});
    buttonAreaOfEffectContainer.appendChild(buttonAreaOfEffect);
    HtmlUtil.appendElements(areaOfEffectContainer, HtmlUtil.toDivPack([labelAreaOfEffect, selectAreaOfEffect]));
    areaOfEffectContainer.appendChild(buttonAreaOfEffectContainer);
    divContentAreaOfEffect.appendChild(areaOfEffectContainer);
    return divContentAreaOfEffect;
}

function getComponentTab(){
    let divContentComponent = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab8", data_group: "referense-tabs"});
    let componentContainer = HtmlUtil.createElement("div", {elementClass: ["componentContainer"]});
    let labelComponent = HtmlUtil.createElement("label", {for: "component", text: game.i18n.localize("MI.referenseContent.component")});
    let selectComponent = HtmlUtil.createElement("select", {id: "component", name: "component"});
    let componentOption = {
        "concentration": game.i18n.localize("MI.referenseContent.componentList.concentration"),
        "material": game.i18n.localize("MI.referenseContent.componentList.material"),
        "ritual": game.i18n.localize("MI.referenseContent.componentList.ritual"),
        "somatic": game.i18n.localize("MI.referenseContent.componentList.somatic"),
        "verbal": game.i18n.localize("MI.referenseContent.componentList.verbal")
    }
    let sortedComponentOption = HtmlUtil.sortDict(componentOption);
    for (let [key, value] of Object.entries(sortedComponentOption)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        selectComponent.appendChild(option);
    }
    let buttonComponentContainer = HtmlUtil.createElement("div", {elementClass: ["buttonComponentContainer"]});
    let buttonComponent = HtmlUtil.createElement("button", {elementClass: ["buttonComponent", "button"], id: "buttonComponent", text: game.i18n.localize("MI.referenseContent.componentList.setComponent")});
    buttonComponentContainer.appendChild(buttonComponent);
    let divComponentPacked = HtmlUtil.toDivPack([labelComponent, selectComponent]);
    divComponentPacked.push(buttonComponentContainer);
    HtmlUtil.appendElements(componentContainer, divComponentPacked);
    divContentComponent.appendChild(componentContainer);
    return divContentComponent;
}

function getSpellSchoolTab(){
    let divContentspellSchool = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab9", data_group: "referense-tabs"});
    let spellSchoolContainer = HtmlUtil.createElement("div", {elementClass: ["spellSchoolContainer"]});
    let labelSpellSchool = HtmlUtil.createElement("label", {for: "spellSchool", text: game.i18n.localize("MI.referenseContent.spellSchool")});
    let spellSchoolOption = {
        "abjuration": game.i18n.localize("MI.referenseContent.spellSchoolList.abjuration"),
        "conjuration": game.i18n.localize("MI.referenseContent.spellSchoolList.conjuration"),
        "divination": game.i18n.localize("MI.referenseContent.spellSchoolList.divination"),
        "enchantment": game.i18n.localize("MI.referenseContent.spellSchoolList.enchantment"),
        "evocation": game.i18n.localize("MI.referenseContent.spellSchoolList.evocation"),
        "illusion": game.i18n.localize("MI.referenseContent.spellSchoolList.illusion"),
        "necromancy": game.i18n.localize("MI.referenseContent.spellSchoolList.necromancy"),
        "transmutation": game.i18n.localize("MI.referenseContent.spellSchoolList.transmutation")
    }
    let selectSpellSchool = HtmlUtil.createElement("select", {id: "spellSchool", name: "spellSchool"});
    let sortedSpellSchoolOption = HtmlUtil.sortDict(spellSchoolOption);
    for(let key in sortedSpellSchoolOption){
        let option = HtmlUtil.createElement("option", {value: key, text: sortedSpellSchoolOption[key]});
        selectSpellSchool.appendChild(option);
    }
    let buttonSpellSchoolContainer = HtmlUtil.createElement("div", {elementClass: ["buttonSpellSchoolContainer"]});
    let buttonSpellSchool = HtmlUtil.createElement("button", {elementClass: ["buttonSpellSchool", "button"],id: "buttonSpellSchool", text: game.i18n.localize("MI.referenseContent.spellSchoolList.setSpellSchool")});
    buttonSpellSchoolContainer.appendChild(buttonSpellSchool);
    HtmlUtil.appendElements(spellSchoolContainer, HtmlUtil.toDivPack([labelSpellSchool, selectSpellSchool]))
    spellSchoolContainer.appendChild(buttonSpellSchoolContainer);
    divContentspellSchool.appendChild(spellSchoolContainer);
    return divContentspellSchool;
}

function getRulesTab(){
    let divContentabirules = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab10", data_group: "referense-tabs"});
    let divrulesContainer = HtmlUtil.createElement("div", {elementClass: ["rulesContainer"]});
    let labelrules = HtmlUtil.createElement("label",{for: "rules", text: game.i18n.localize("MI.referenseContent.rules")});
    let rulesOptions = [
        "inspiration", "carryingcapacity", "push", "lift", "drag", "encumbrance",
        "hiding", "passiveperception", "time", "speed", "travelpace", "forcedmarch",
        "difficultterrainpace", "climbing", "swimming", "longjump", "highjump", "falling",
        "suffocating", "vision", "light", "lightlyobscured", "heavilyobscured", "brightlight",
        "dimlight", "darkness", "blindsight", "darkvision", "tremorsense", "truesight",
        "food", "water", "resting", "shortrest", "longrest", "surprise",
        "initiative", "bonusaction", "reaction", "difficultterrain", "beingprone", "droppingprone",
        "standingup", "crawling", "movingaroundothercreatures", "flying", "size", "space",
        "squeezing", "attack", "castaspell", "dash", "disengage", "dodge",
        "help", "hide", "ready", "search", "useanobject", "attackrolls",
        "unseenattackers", "unseentargets", "rangedattacks", "range", "rangedattacksinclosecombat", "meleeattacks",
        "reach", "unarmedstrike", "opportunityattacks", "twoweaponfighting", "grappling", "escapingagrapple",
        "movingagrappledcreature", "shoving", "cover", "halfcover", "threequarterscover", "totalcover",
        "hitpoints", "damagerolls", "criticalhits", "damagetypes", "damageresistance", "damagevulnerability",
        "healing", "instantdeath", "deathsavingthrows", "deathsaves", "stabilizing", "knockingacreatureout",
        "temporaryhitpoints", "temphp", "mounting", "dismounting", "controllingamount", "underwatercombat",
        "spelllevel", "knownspells", "preparedspells", "spellslots", "castingatahigherlevel", "upcasting",
        "castinginarmor", "cantrips", "rituals", "castingtime", "bonusactioncasting", "reactioncasting",
        "longercastingtimes", "spellrange", "components", "verbal", "spellduration", "instantaneous",
        "concentrating", "spelltargets", "areaofeffect", "pointoforigin", "spellsavingthrows", "spellattackrolls",
        "combiningmagicaleffects", "schoolsofmagic", "detectingtraps", "disablingtraps", "curingmadness", "damagethreshold",
        "poisontypes", "contactpoison", "ingestedpoison", "inhaledpoison", "injurypoison", "attunement",
        "wearingitems", "wieldingitems", "multipleitemsofthesamekind", "paireditems", "commandword", "consumables",
        "itemspells", "charges", "spellscroll", "creaturetags", "telepathy", "legendaryactions",
        "lairactions", "regionaleffects", "disease"
    ];
    let rulesOptionsDict = {};
    for (let rule of rulesOptions) {
        rulesOptionsDict[rule] = game.i18n.localize(`MI.referenseContent.rulesList.${rule}`);
    };
    rulesOptions = HtmlUtil.sortDict(rulesOptionsDict);

    let rulesSelect = HtmlUtil.createElement("select", {id:"rulesSelect", name:"rulesSelect"});
    for (let [key, value] of Object.entries(rulesOptions)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        rulesSelect.appendChild(option);
    }

    let buttonRulesContainer = HtmlUtil.createElement("div", {elementClass: ["buttonRulesContainer"]});
    let buttonRules = HtmlUtil.createElement("button", {elementClass: ["buttonRules", "button"], id:"buttonRules", text: game.i18n.localize("MI.referenseContent.rulesList.setRules")});
    buttonRulesContainer.appendChild(buttonRules);
    HtmlUtil.appendElements(divrulesContainer, HtmlUtil.toDivPack([labelrules, rulesSelect]));
    divrulesContainer.appendChild(buttonRulesContainer);
    divContentabirules.appendChild(divrulesContainer);
    return divContentabirules;
}